#include "mainwindowimpl.h"
#include <QApplication>

MainWindowImpl::MainWindowImpl(QWidget *parent, Qt::WFlags f)
	: QMainWindow(parent, f)
{
	setupUi(this);
	status_label->hide();
	progress_bar->setValue(0);
	progress_bar->hide();
	ssh_thread = NULL;
}

void MainWindowImpl::setupUi(QMainWindow *MainWindow)
{
	if (MainWindow->objectName().isEmpty())
		MainWindow->setObjectName(QString::fromUtf8("MainWindow"));

	MainWindow->setWindowModality(Qt::NonModal);
	MainWindow->resize(550, 180);
	QSizePolicy sizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
	sizePolicy.setHorizontalStretch(0);
	sizePolicy.setVerticalStretch(0);
	sizePolicy.setHeightForWidth(MainWindow->sizePolicy()
			.hasHeightForWidth());
	MainWindow->setSizePolicy(sizePolicy);
	centralwidget = new QWidget(MainWindow);
	centralwidget->setObjectName(QString::fromUtf8("centralwidget"));
	sizePolicy.setHeightForWidth(centralwidget->sizePolicy()
			.hasHeightForWidth());
	centralwidget->setSizePolicy(sizePolicy);
	centralwidget->setLayoutDirection(Qt::LeftToRight);
	verticalLayout_2 = new QVBoxLayout(centralwidget);
	verticalLayout_2->setSpacing(6);
	verticalLayout_2->setObjectName(QString::fromUtf8("verticalLayout_2"));
	verticalLayout = new QVBoxLayout();
	verticalLayout->setSpacing(6);
	verticalLayout->setObjectName(QString::fromUtf8("verticalLayout"));
	horizontalLayout_ip = new QHBoxLayout();
	horizontalLayout_ip->setSpacing(6);
	horizontalLayout_ip->setObjectName(
			QString::fromUtf8("horizontalLayout_ip"));
	ip_label = new QLabel(centralwidget);
	ip_label->setObjectName(QString::fromUtf8("ip_label"));
	QSizePolicy sizePolicy1(QSizePolicy::Preferred,
			QSizePolicy::MinimumExpanding);
	sizePolicy1.setHorizontalStretch(0);
	sizePolicy1.setVerticalStretch(0);
	sizePolicy1.setHeightForWidth(ip_label->sizePolicy()
			.hasHeightForWidth());
	ip_label->setSizePolicy(sizePolicy1);
	ip_label->setLayoutDirection(Qt::RightToLeft);

	horizontalLayout_ip->addWidget(ip_label);

	ip1_le = new QLineEdit(centralwidget);
	ip1_le->setObjectName(QString::fromUtf8("ip1_le"));
	sizePolicy.setHeightForWidth(ip1_le->sizePolicy().hasHeightForWidth());
	ip1_le->setSizePolicy(sizePolicy);

	horizontalLayout_ip->addWidget(ip1_le);

	verticalLayout->addLayout(horizontalLayout_ip);

	verticalSpacer_2 = new QSpacerItem(20, 40, QSizePolicy::Minimum,
			QSizePolicy::Expanding);

	verticalLayout->addItem(verticalSpacer_2);

	horizontalLayout_file = new QHBoxLayout();
	horizontalLayout_file->setSpacing(6);
	horizontalLayout_file->setObjectName(
			QString::fromUtf8("horizontalLayout_file"));
	firmware_label = new QLabel(centralwidget);
	firmware_label->setObjectName(QString::fromUtf8("firmware_label"));
	sizePolicy1.setHeightForWidth(firmware_label->sizePolicy()
			.hasHeightForWidth());
	firmware_label->setSizePolicy(sizePolicy1);
	firmware_label->setLayoutDirection(Qt::RightToLeft);

	horizontalLayout_file->addWidget(firmware_label);

	file_le = new QLineEdit(centralwidget);
	file_le->setObjectName(QString::fromUtf8("file_le"));
	sizePolicy.setHeightForWidth(
			file_le->sizePolicy().hasHeightForWidth());
	file_le->setSizePolicy(sizePolicy);

	horizontalLayout_file->addWidget(file_le);

	browse_pb = new QPushButton(centralwidget);
	browse_pb->setObjectName(QString::fromUtf8("browse_pb"));
	QSizePolicy sizePolicy2(QSizePolicy::Preferred,
			QSizePolicy::Expanding);
	sizePolicy2.setHorizontalStretch(0);
	sizePolicy2.setVerticalStretch(0);
	sizePolicy2.setHeightForWidth(browse_pb->sizePolicy()
			.hasHeightForWidth());
	browse_pb->setSizePolicy(sizePolicy2);

	horizontalLayout_file->addWidget(browse_pb);

	verticalLayout->addLayout(horizontalLayout_file);

	verticalSpacer = new QSpacerItem(20, 40, QSizePolicy::Minimum,
			QSizePolicy::Expanding);

	verticalLayout->addItem(verticalSpacer);

	horizontalLayout_buttons = new QHBoxLayout();
	horizontalLayout_buttons->setSpacing(6);
	horizontalLayout_buttons->setObjectName(
			QString::fromUtf8("horizontalLayout_buttons"));
	horizontalSpacer = new QSpacerItem(40, 20, QSizePolicy::Expanding,
			QSizePolicy::Minimum);

	horizontalLayout_buttons->addItem(horizontalSpacer);

	start_pb = new QPushButton(centralwidget);
	start_pb->setObjectName(QString::fromUtf8("start_pb"));
	sizePolicy.setHeightForWidth(start_pb->sizePolicy()
			.hasHeightForWidth());
	start_pb->setSizePolicy(sizePolicy);
	start_pb->setMinimumSize(QSize(150, 0));

	horizontalLayout_buttons->addWidget(start_pb);

	horizontalSpacer_2 = new QSpacerItem(40, 20, QSizePolicy::Expanding,
			QSizePolicy::Minimum);

	horizontalLayout_buttons->addItem(horizontalSpacer_2);

	verticalLayout->addLayout(horizontalLayout_buttons);

	verticalLayout_status = new QVBoxLayout();
	verticalLayout_status->setSpacing(6);
	verticalLayout_status->setObjectName(
			QString::fromUtf8("verticalLayout_status"));
	status_label = new QLabel(centralwidget);
	status_label->setObjectName(QString::fromUtf8("status_label"));
	status_label->setEnabled(true);
	QSizePolicy sizePolicy3(QSizePolicy::MinimumExpanding,
			QSizePolicy::MinimumExpanding);
	sizePolicy3.setHorizontalStretch(0);
	sizePolicy3.setVerticalStretch(0);
	sizePolicy3.setHeightForWidth(status_label->sizePolicy()
			.hasHeightForWidth());
	status_label->setSizePolicy(sizePolicy3);

	verticalLayout_status->addWidget(status_label);

	progress_bar = new QProgressBar(centralwidget);
	progress_bar->setObjectName(QString::fromUtf8("progress_bar"));
	sizePolicy.setHeightForWidth(progress_bar->sizePolicy()
			.hasHeightForWidth());
	progress_bar->setSizePolicy(sizePolicy);
	progress_bar->setValue(24);

	verticalLayout_status->addWidget(progress_bar);
	verticalLayout->addLayout(verticalLayout_status);
	verticalLayout_2->addLayout(verticalLayout);

	MainWindow->setCentralWidget(centralwidget);

	retranslateUi(MainWindow);
	QObject::connect(browse_pb, SIGNAL(clicked()), MainWindow,
			SLOT(browseClicked()));
	QObject::connect(start_pb, SIGNAL(clicked()), MainWindow,
			SLOT(startClicked()));

	QMetaObject::connectSlotsByName(MainWindow);
}

void MainWindowImpl::retranslateUi(QMainWindow *MainWindow)
{
	MainWindow->setWindowTitle(QApplication::translate("MainWindow",
				"ArVerify", 0, QApplication::UnicodeUTF8));
	ip_label->setText(QApplication::translate("MainWindow",
				"Adres rejestratora", 0,
				QApplication::UnicodeUTF8));
	firmware_label->setText(QApplication::translate("MainWindow",
				"Plik firmware", 0,
				QApplication::UnicodeUTF8));
	browse_pb->setText(QApplication::translate("MainWindow",
				"Przegl\304\205daj...", 0,
				QApplication::UnicodeUTF8));
	start_pb->setText(QApplication::translate("MainWindow",
				"Weryfikuj", 0, QApplication::UnicodeUTF8));
	status_label->setText(QApplication::translate("MainWindow",
				"Weryfikowanie...", 0,
				QApplication::UnicodeUTF8));
}

MainWindowImpl::~MainWindowImpl()
{
	if (QFile::exists(public_key_tmp_file))
		QFile::remove(public_key_tmp_file);
	if (QFile::exists(private_key_tmp_file))
		QFile::remove(private_key_tmp_file);
}

void MainWindowImpl::browseClicked()
{
	QString s = QFileDialog::getOpenFileName(this,
			QString::fromUtf8("Przeglądaj pliki"));
	file_le->setText(s);
}

void MainWindowImpl::startClicked()
{
	QStringList remote_host;
	QString host;
	FirmwareFile *file;
	int port = 22;
	bool ok = false;

	/*
	 * currently disabling GUI is racy and we need to protect
	 * against concurent executions
	 */
	if (ssh_thread != NULL)
		return;

	if (!validateHost()) {
		QMessageBox::information(this, "Adres rejestratora",
			QString::fromUtf8("Podaj prawidłowy adres "
				"rejestratora"));
		return;
	}
	if (!QFile::exists(file_le->text())) {
		QMessageBox::information(this, "Plik firmware",
			QString::fromUtf8("Podaj ścieżkę do "
					"istniejącego pliku firmware"));
		return;
	}

	file = new FirmwareFile(file_le->text());
	if (!file->isValid()) {
		QMessageBox::information(0, "Plik firmware",
			QString::fromUtf8("Nieprawidłowy plik firmware"));
		goto out_free_file;
	}

	private_key_tmp_file = file_le->text() + "_tmp_private";
	public_key_tmp_file = file_le->text() + "_tmp_public";

	if (!writeTmpKey(private_key_tmp_file, file->getPrivateKey())) {
		QMessageBox::information(0, "Plik firmware",
			QString::fromUtf8("Nieprawidłowy plik firmware"));
		goto out_free_file;
	}

	if (!writeTmpKey(public_key_tmp_file, file->getPublicKey())) {
		QMessageBox::information(0, "Plik firmware",
			QString::fromUtf8("Nieprawidłowy plik firmware"));
		goto out_free_file;
	}

	remote_host = ip1_le->text().trimmed().split(':',
			QString::SkipEmptyParts);
	host = remote_host.at(0);
	if (remote_host.size() > 1) {
		port = remote_host.at(1).toInt(&ok);
		if (!ok)
			port = 22;
	}

	ssh_thread = new SshThread(public_key_tmp_file,
				private_key_tmp_file, host, port,
				file->getSerialNumber());

	connect(ssh_thread, SIGNAL(started()), SLOT(disableInterface()));
	connect(ssh_thread, SIGNAL(finished()), SLOT(threadFinished()));
	connect(ssh_thread, SIGNAL(terminated()), SLOT(threadTerminated()));
	connect(ssh_thread, SIGNAL(verProgress(int)),
			SLOT(updateProgress(int)));
	connect(ssh_thread, SIGNAL(verStatus(QString)),
						SLOT(updateStatus(QString)));

	ssh_thread->start();

out_free_file:
	delete file;
}

void MainWindowImpl::updateProgress(int progress)
{
	if (progress > progress_bar->value())
		progress_bar->setValue(progress);
}

void MainWindowImpl::updateStatus(QString str, bool warning)
{
	if (warning)
		status_label->setText("<font color='red'>" + str + "</font>");
	else
		status_label->setText(str);
}

void MainWindowImpl::updateStatus(QString str)
{
	status_label->setText(str);
}

void MainWindowImpl::threadTerminated()
{
	threadFinished();
}

void MainWindowImpl::threadFinished()
{
	if (QFile::exists(public_key_tmp_file))
		QFile::remove(public_key_tmp_file);
	if (QFile::exists(private_key_tmp_file))
		QFile::remove(private_key_tmp_file);

	switch (ssh_thread->getValidationStatus()) {
		case CONNECTION_FAILED:
		case INIT_FAILED:
		case CHANNEL_INIT_FAIL:
		case SESSION_INIT_FAIL:
		case COMMAND_ERROR:
		case STREAM_ERROR:
		case PARSE_ERROR:
		case CHENNEL_END:
			updateStatus(QString::fromUtf8("Nie można "
				"ustanowić połączenia z rejestratorem"),
				true);
			break;
		case PUBLIC_KEY_FAILED:
		case PRIVATE_KEY_FAILED:
		case AUTH_FAILED:
		case AUTH_PARTIAL:
			updateStatus(QString
				::fromUtf8("Błąd autoryzacji."), true);
			break;
		case UNKNOWN_ERROR:
		case NOT_STARTED:
			updateStatus(QString::fromUtf8("Wystąpił "
				"nieznany problem. Nie można dokończyć "
				"weryfikacji..."), true);
			break;
		case SESSION_TIMEOUT:
			updateStatus(QString::fromUtf8("Połączenie "
				"zostało przerwane. Sprawdź sieć i "
				"uruchom weryfikację ponownie..."), true);
			break;
		case SERIAL_MISMATCH:
			updateStatus(QString::fromUtf8("Występuje"
				" niezgodność firmwaru w pliku i "
				"w rejestratorze"), true);
			break;
		case FIRMWARE_CORRUPTED:
			updateStatus(QString::fromUtf8("Występuje"
				" niezgodność firmwaru w pliku i "
				"w rejestratorze"), true);
			break;
		case SUCCESS:
			updateStatus(QString::fromUtf8("Firmware "
				"rejestratora jest zgodny z plikiem"));
			break;
	}

	delete ssh_thread;
	ssh_thread = NULL;
	enableInterface();
}

bool MainWindowImpl::writeTmpKey(QString path, firmware_ssh_key key)
{
	bool ret = false;
	QFile file(path);
	if (!file.open(QIODevice::WriteOnly))
		return false;
	QDataStream out(&file);
	out.setByteOrder(QDataStream::LittleEndian);
	ret = (out.writeRawData((const char *)key.bytes, key.length)
			== (int64_t)key.length);
	file.flush();
	file.close();
	return ret;
}

bool MainWindowImpl::validateHost()
{
	if (ip1_le->text().length() < 1)
		return false;
	return true;
}

void MainWindowImpl::enableInterface()
{
	progress_bar->setVisible(false);
	ip1_le->setDisabled(false);
	file_le->setDisabled(false);
	browse_pb->setDisabled(false);
	start_pb->setDisabled(false);
}

void MainWindowImpl::disableInterface()
{
	progress_bar->setValue(0);
	status_label->setVisible(true);
	progress_bar->setVisible(true);
	ip1_le->setDisabled(true);
	file_le->setDisabled(true);
	browse_pb->setDisabled(true);
	start_pb->setDisabled(true);
}
