#ifndef MAINWINDOWIMPL_H
#define MAINWINDOWIMPL_H

#include <QMainWindow>
#include <QIntValidator>
#include <QFileDialog>
#include <QMessageBox>
#include <QTextStream>
#include <QObject>
#include "firmwarefile.h"
#include "sshthread.h"

#include <QHBoxLayout>
#include <QLabel>
#include <QLineEdit>
#include <QProgressBar>
#include <QPushButton>
#include <QSpacerItem>
#include <QVBoxLayout>
#include <QWidget>
#include <QTimer>

class MainWindowImpl : public QMainWindow {
Q_OBJECT
private:
	QString private_key_tmp_file;
	QString public_key_tmp_file;
	bool writeTmpKey(QString path, firmware_ssh_key key);
	bool validateHost();
	SshThread *ssh_thread;
	QWidget *centralwidget;
	QVBoxLayout *verticalLayout_2;
	QVBoxLayout *verticalLayout;
	QHBoxLayout *horizontalLayout_ip;
	QLabel *ip_label;
	QLineEdit *ip1_le;
	QSpacerItem *verticalSpacer_2;
	QHBoxLayout *horizontalLayout_file;
	QLabel *firmware_label;
	QLineEdit *file_le;
	QPushButton *browse_pb;
	QSpacerItem *verticalSpacer;
	QHBoxLayout *horizontalLayout_buttons;
	QSpacerItem *horizontalSpacer;
	QPushButton *start_pb;
	QSpacerItem *horizontalSpacer_2;
	QVBoxLayout *verticalLayout_status;
	QLabel *status_label;
	QProgressBar *progress_bar;

	void setupUi(QMainWindow *MainWindow);
	void retranslateUi(QMainWindow *MainWindow);

public:
	MainWindowImpl(QWidget *parent = 0, Qt::WFlags f = 0);
	~MainWindowImpl();

private slots:
	void browseClicked();
	void startClicked();
	void disableInterface();
	void enableInterface();
	void threadTerminated();
	void threadFinished();
	void updateProgress(int progress);
	void updateStatus(QString str);
	void updateStatus(QString str, bool warning);
};
#endif
